# Chapter2.py

# page 35

'''
Java example -> Explicitly define the data type
string firstName = "Bob"; -> declare a string and name it firstName, assign a string value of Bob to the variable name
string varName = string value
= assigns value
== tests value
=== test type and value

Python -> Implicitly defines all types
lastName = "Smith" -> variable lastName is assigned Smith as string type
varName = value as string
= assigns value
== tests value
'''

# 3 base data types in python
firstName = "Bob" # single or double quotes string type
'''
` tick -> injectors for strings
' single -> wrapper for strings
" double -> value for strings
example => `SELECT * 'from tblContacts where state="Florida" ' `
'''

age = 21 # digit [0-9] with no wrapper is an integer type

price = 25.52 # digit [0-9] with a dotNotation is a float type

# other types
vipStatus = True # boolean
# invoiceDate = 2025-01-13 11:58:03.123456 # datetime 

# strings
## strings can be wrapped with single or double quotes
## string type is the DEFAULT for ALL inputs (OOP)  input()

firstName = "Bob" # preferred
lastName = 'Smith'

# 3 methods for creating string objects as fullName
## use a join operator to join string types "friends"
join_fullName = firstName + ' ' + lastName # concat in Excel
# string + string + string
print(join_fullName)

## use a template variable with the f keyword and values
## template variables !dataType -> everyone can be a friend
## most widely used and acceptable method in python
tv_fullName = f"{firstName} {lastName}"
print(tv_fullName)

## use parameters to create new objects in memory
## this method is important to use when we want to take objects and create new objects
param_fullName = firstName, lastName
print(param_fullName) # print different than the other 2 methods

# what happens when objects are NOT friends
## cast or covert strangers to friends
## string + string + int -> int a string
age = 25

# Create a contactInfo variable and string all 3 objects
## If we use the type, they have to be converted
join_contactInfo = firstName + ' ' + lastName + ' ' + str(age)
print(join_contactInfo)

## If we use the f keyword, everyone is already friends because we DO NOT care about anything but the human. aka we ignore their drama
tv_contactInfo = f"{firstName} {lastName} {age}"
print(tv_contactInfo)

# Numbers
# page 38

print("=== Numbers ===")

'''
How we can better declare the variables for memory optimization / processing

Python uses the end of line as its interpreter
C#, Java and others use the ;  string fName; string lName;
'''

x = 7 # int
y = 2.5 # float

x1, y1 = 7, 2.5

# arithmetic operations
z = x + y # Numbers althought int + float are friends
print(z)

z1 = x * y
print(z1)

# z2 = x / 0  # ZERODIVISIONERROR althought two values are friends
z3 = 0 / x

z3 = (x + y) * 3 # Order of Precedence must be followed

z4 = x + (y * 3) # best practice is to still confirm all Order of Precedence with a wrapper

# The + symbol can mean different types
z5 = 7 + 7  # 14 using the arithmetic operator
z6 = '7' + '7' # 77 using the join operator
# z7 = 7 + '7' # error
# another example
z8 = '7' * 7 # 7777777 using an interator operator
# z9 = 7 * '7' # error

# Ask the user to enter quantity needed, then multiply it by a price variable with value of 25.75

str_quantity = input("Quantity needed: ") # string '4' ? 
int_quantity = int(str_quantity) # only create this obj in memory IF you were going to use it that way
price = 25.75
lineTotal = int_quantity * price
print(lineTotal)

# Python Core Functions
# page 50
# 5 common functions we use in Python
# input(), print(), int(), str(), float()

'''
Python -> python.org 3.13
Core 3 -> functions and features you get when you install python
Standard / Version .13
Custom -> your modules and 3rd party pip
'''

# Ask the user for their first and last name and zip code. Use fname, lName and zip for the variable names, and create a string that looks like:
# First Name: Bob Last Name: Smith Zip Code: 12345

# Create the 3 inputs
fName = input("Enter your first name: ")
lName = input("Enter your last name: ")
zip = input("Enter your zip code: ")

# Create the user information string
userInformation = f"First Name: {fName} Last Name: {lName} Zip Code: {zip}"
userInformation1 = "First Name: " + fName + " Last Name: " + lName + ' ' + "Zip Code: " + zip

# output the results
print(userInformation)
print(userInformation1)

# EOF