# Chapter5and8.py

'''
Debug thru Assertion Testing Principles

Debug Errors <unexpected exit code 1> Layer 1
Syntax Errors -> There is NO reason to run the program if you have syntax error. In VS Code <IDE> they call these "Problems", in Visual Studio these are in the "Debug Console"
Runtime Errors -> Runtime errors occur when you run the program, but the program can not initialize. At this point <minus SyntaxError class> the syntax will be correct, but the program can't start. __init__ 

<developers / programmers>

Exception Handlers <expected exit code 1 -> handle the exit code 1> Layer 2
Exception Class errors AFTER runtime -> An instance of a class "throws" an error. In python this is normally handled by the try/except keyword block or throws keyword on the function/method/class

Testing Layer 3
UI/UX Testing -> User Interface / User Experience <designer> UI -> look and feel  UX -> bouncing ball
Unit Testing -> mockito/class and function testing/performance testing Level 2 (pytest) 
Assertion Testing -> Expected vs Actual Return Level 2 (pytest)
'''

# Chapter 5 try/except block -> MyApplication.py
## the keywords for the try / except block
### try and except are required
### finally is optional BUT highly recommended

try:
    pass
    # try keyword will "try" using EAFP principles on each individual line of code
    # if the EXPECTED line of code will run, python runs the line
    # if the line is EXPECTING to fail, we pass the exit code to the "except" block

# Prioritize the Exception
except ImportError as err:
    print("You are missing an import module or object that is being called, or you do not have proper access to the module or object.")

# DivideByZero Exception
except ZeroDivisionError as err:
    print("You can not divide a number by zero, please enter a valid digit greater than zero.")
    print("Loop the user back to the form/input/whatever")
    # call functions and methods to control what happens next

# General Exception
except Exception as err: # catch the general exception class and assign the error to value
    print(err)
    # You can prioritize your exception classes, BUT the general exception class "Exception" must be at the end and always exist.

finally:
    pass
    # The finally block will ALWAYS run no matter if the program exits with Exit Code 0 <pass> or Exit Code 1 <fail>
    # Close IO's, data streams, db conn, garbage collection to handle memory, run finalizers, ...

# the try/except block can either run on the complete program OR an individual block of code

print("=== Connect to a SQL DB ===")

orderTotal = 500.00

print("Submit order to database")

try:
    print("try and connect to db")
    try:
        print("run the connector")
    except Exception as err:
        print("can not connect, SQL server does not exist or respond")

    print("log the user into the db")
    try:
        print("Pass the username and password and validate the user")
        # try block username test
        # try block password test
    except Exception as err:
        print("Bad username or password")

except Exception as err:
    print(err)


# EOF