# Orders.py

import datetime
import csv


# Globals -> creating attrs in level 2
# glb_invoiceDate, glb_dueDate = orderInformation()


'''Testing
from DataSets import dataSets

# Get the data for the customer order
# web page, desktop app, data stream, ...
firstName, lastName, orderID, orderDate, orderProcessed, ccApproved, subTotal, taxPerc = dataSets() # run input()'s and return 2 args
'''
# Customer Information 
def customerInformation(param_firstname, param_lastName):
    '''
    The customer information function will take 2 string arguments from user inputs in the application. The function will return a fullname as string object to the application.
    '''
    firstName = param_firstname
    lastName = param_lastName
    fullName = f"{firstName} {lastName}"
    return fullName # -> str
    # the return keyword returns the VALUE of the variable to the application, rather than holding it in the funtion
    # the return is ALWAYS the last operation in the scope of a function/method
    # all returns are built as tuples (return values are immutable)

# Order Information
# Chapter 11 page 303 datetime module
'''
module name datetime

common class names you will use oftem form the datetime module
datetime -> date and time as yyyy-mm-dd hh:mm:ss.mmmmmm
date -> date as yyyy-mm-dd 12:00:00.000000 or 00:00:00.000000
time -> time as hh:mm:ss.mmmmmm -> there is no date object
timedelta -> used to calculate off the date and time -> timedelta(days=30)
2% 10 Net 30
if (date_paid - timedelta(days=10)) == dueDate: calc 2 % discount
# date_paid - 10 # error
datetimeVar - datetimeVar = value
'''
def orderInformation():
    
    # Create the invoice date using now()
    invoiceDate = datetime.datetime.now()

    # Calculate the due date based on terms
    customerTerms = "Net 30"

    if customerTerms == "Due on Receipt":
        term = 0
    elif customerTerms == "Net 30":
        term = 30
    elif customerTerms == "Net 60":
        term = 60
    else:
        term = 0 

    dueDate = invoiceDate + datetime.timedelta(days=term)

    # Display the datetime format
    print(f"Invoice Date as datetime: {invoiceDate}")
    print(f"Due Date as datetime: {dueDate}")

    # Readable string format page 309 chart of date time code
    # 01-16-2025
    dateFormat = "%m-%d-%Y"

    str_invoiceDate = invoiceDate.strftime(dateFormat)
    str_dueDate = dueDate.strftime(dateFormat)

    # Display the formatted datetime
    print(f"Invoice Date: {str_invoiceDate}")
    print(f"Due Date: {str_dueDate}")

    return invoiceDate, dueDate # datetime -> csv

# test Orders.py -> remove when done -> app
# orderInformation()
# Terminal Output Copied to Comment Block
'''
Invoice Date as datetime: 2025-01-16 11:37:49.320371
Due Date as datetime: 2025-02-15 11:37:49.320371
Invoice Date: 01-16-2025
Due Date: 02-15-2025
'''

# Order Details
def orderDetails():
    pass

# Local variables for functions -> replace this with attributes in level 2
glb_invoiceDate, glb_dueDate = orderInformation()

def write_to_csv(param_orderID, param_cartTotal, param_invoiceDate, param_dueDate):
    # step 1 -> setup and test the call to the function and assign data
    var_orderID = param_orderID
    var_cartTotal = param_cartTotal
    var_invoiceDate = param_invoiceDate
    var_dueDate = param_dueDate

    # step 2 -> do the functions operations
    # fileIO using a csv page 216

    # Create a filename orders_mmddyyyy.csv
    todaysOrders = datetime.datetime.now()
    dateFilepath = todaysOrders.strftime("%m%d%Y") # orders_01162025.csv
    fileName = f"orders_{dateFilepath}.csv"

    # relative paths
    relativePath = "../Shop/" # \\ os module
    relativeFilePath = relativePath + dateFilepath  # join Object OS !f" "

    # absolute paths
    absolutePath = "C:\\Users\\Student/Desktop/PythonLevel10113/"
    absoluteFilePath = absolutePath + dateFilepath # join Object OS !f""

    # Check both if the file exists AND only write the header row / fieldnames only once
    # FileExistsError -> we want to ignore this part of the operation
    try:
        with open(fileName, 'x', newline='') as file:
            writer = csv.writer(file) # varScope:as varFunction or string
            # write the header/fieldnames to row 1
            writer.writerow(['Order ID', 'cartTotal', 'Invoice Date', 'dueDate'])

            # write the order information
            writer.writerow([var_orderID, f"{var_cartTotal:.2f}", var_invoiceDate, var_dueDate])

    except FileExistsError:
        with open(fileName, 'a', newline='') as file:
            writer = csv.writer(file)

            # if the file exists we only need to write the data row 
            # write the order information
            writer.writerow([var_orderID, f"{var_cartTotal:.2f}", var_invoiceDate, var_dueDate])

# EOF